
/* 
* Copyright 2014 Amazon.com,
* Inc. or its affiliates. All Rights Reserved.
*
* Licensed under the Apache License, Version 2.0 (the
* "License"). You may not use this file except in compliance
* with the License. A copy of the License is located at
*
* http://aws.amazon.com/apache2.0/
*
* or in the "license" file accompanying this file. This file is
* distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
* CONDITIONS OF ANY KIND, either express or implied. See the
* License for the specific language governing permissions and
* limitations under the License.
*/

using System.Runtime.InteropServices;
#if UNITY_ANDROID
using UnityEngine;
#endif
namespace com.amazon.whisperplay.fling.cpt.media.service
{
    public abstract partial class AmazonFlingPlayerServiceImpl
    {
#if UNITY_ANDROID
        private class AmazonFlingPlayerServiceUnityAndroid : AmazonFlingPlayerServiceUnityBase
        {
            [DllImport ("AmazonFlingPlayerServiceBridge")]
            private static extern string nativeRegisterCallbackGameObject(string name);


            [DllImport ("AmazonFlingPlayerServiceBridge")]
            private static extern string nativeInit();

            [DllImport ("AmazonFlingPlayerServiceBridge")]
            private static extern string nativeStartServiceJson(string jsonMessage);

            [DllImport ("AmazonFlingPlayerServiceBridge")]
            private static extern string nativeUpdateVolumeJson(string jsonMessage);

            [DllImport ("AmazonFlingPlayerServiceBridge")]
            private static extern string nativeUpdateMuteJson(string jsonMessage);

            [DllImport ("AmazonFlingPlayerServiceBridge")]
            private static extern string nativeUpdatePositionJson(string jsonMessage);

            [DllImport ("AmazonFlingPlayerServiceBridge")]
            private static extern string nativeUpdateDurationJson(string jsonMessage);

            [DllImport ("AmazonFlingPlayerServiceBridge")]
            private static extern string nativeUpdateMediaStateJson(string jsonMessage);

            [DllImport ("AmazonFlingPlayerServiceBridge")]
            private static extern string nativeUpdateMediaConditionJson(string jsonMessage);

            [DllImport ("AmazonFlingPlayerServiceBridge")]
            private static extern string nativeAddSupportedMimeTypeJson(string jsonMessage);

            [DllImport ("AmazonFlingPlayerServiceBridge")]
            private static extern string nativeUpdateMediaPlayerInfoJson(string jsonMessage);

            public static new AmazonFlingPlayerServiceUnityAndroid Instance
            {
                get
                {
                    return AmazonFlingPlayerServiceUnityBase.getInstance<AmazonFlingPlayerServiceUnityAndroid>();
                }
            }

            protected override void NativeInit()
            {
                AmazonFlingPlayerServiceUnityAndroid.nativeInit();
            }

            protected override void RegisterCallback()
            {
                AmazonFlingPlayerServiceUnityAndroid.nativeRegisterCallbackGameObject(gameObject.name);
            }

            protected override void RegisterEventListener()
            {
                AmazonFlingPlayerServiceUnityAndroid.nativeRegisterCallbackGameObject(gameObject.name);
            }

            protected override void NativeRegisterCrossPlatformTool(string crossPlatformTool)
            {
            }

            protected override string NativeStartServiceJson(string jsonMessage)
            {
                return AmazonFlingPlayerServiceUnityAndroid.nativeStartServiceJson(jsonMessage);
            }

            protected override string NativeUpdateVolumeJson(string jsonMessage)
            {
                return AmazonFlingPlayerServiceUnityAndroid.nativeUpdateVolumeJson(jsonMessage);
            }

            protected override string NativeUpdateMuteJson(string jsonMessage)
            {
                return AmazonFlingPlayerServiceUnityAndroid.nativeUpdateMuteJson(jsonMessage);
            }

            protected override string NativeUpdatePositionJson(string jsonMessage)
            {
                return AmazonFlingPlayerServiceUnityAndroid.nativeUpdatePositionJson(jsonMessage);
            }

            protected override string NativeUpdateDurationJson(string jsonMessage)
            {
                return AmazonFlingPlayerServiceUnityAndroid.nativeUpdateDurationJson(jsonMessage);
            }

            protected override string NativeUpdateMediaStateJson(string jsonMessage)
            {
                return AmazonFlingPlayerServiceUnityAndroid.nativeUpdateMediaStateJson(jsonMessage);
            }

            protected override string NativeUpdateMediaConditionJson(string jsonMessage)
            {
                return AmazonFlingPlayerServiceUnityAndroid.nativeUpdateMediaConditionJson(jsonMessage);
            }

            protected override string NativeAddSupportedMimeTypeJson(string jsonMessage)
            {
                return AmazonFlingPlayerServiceUnityAndroid.nativeAddSupportedMimeTypeJson(jsonMessage);
            }

            protected override string NativeUpdateMediaPlayerInfoJson(string jsonMessage)
            {
                return AmazonFlingPlayerServiceUnityAndroid.nativeUpdateMediaPlayerInfoJson(jsonMessage);
            }

        }
#endif
    }
}

