
/* 
* Copyright 2014 Amazon.com,
* Inc. or its affiliates. All Rights Reserved.
*
* Licensed under the Apache License, Version 2.0 (the
* "License"). You may not use this file except in compliance
* with the License. A copy of the License is located at
*
* http://aws.amazon.com/apache2.0/
*
* or in the "license" file accompanying this file. This file is
* distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
* CONDITIONS OF ANY KIND, either express or implied. See the
* License for the specific language governing permissions and
* limitations under the License.
*/

using System.Runtime.InteropServices;
#if UNITY_ANDROID
using UnityEngine;
#endif
namespace com.amazon.whisperplay.fling.cpt.media.controller
{
    public abstract partial class AmazonFlingServiceImpl
    {
#if UNITY_ANDROID
        private class AmazonFlingServiceUnityAndroid : AmazonFlingServiceUnityBase
        {
            [DllImport ("AmazonFlingServiceBridge")]
            private static extern string nativeRegisterCallbackGameObject(string name);


            [DllImport ("AmazonFlingServiceBridge")]
            private static extern string nativeInit();

            [DllImport ("AmazonFlingServiceBridge")]
            private static extern string nativeStartDiscoveryJson(string jsonMessage);

            [DllImport ("AmazonFlingServiceBridge")]
            private static extern string nativeStopDiscoveryJson(string jsonMessage);

            [DllImport ("AmazonFlingServiceBridge")]
            private static extern string nativeGetVolumeJson(string jsonMessage, string callerId);

            [DllImport ("AmazonFlingServiceBridge")]
            private static extern string nativeSetVolumeJson(string jsonMessage, string callerId);

            [DllImport ("AmazonFlingServiceBridge")]
            private static extern string nativeIsMuteJson(string jsonMessage, string callerId);

            [DllImport ("AmazonFlingServiceBridge")]
            private static extern string nativeSetMuteJson(string jsonMessage, string callerId);

            [DllImport ("AmazonFlingServiceBridge")]
            private static extern string nativeGetPositionJson(string jsonMessage, string callerId);

            [DllImport ("AmazonFlingServiceBridge")]
            private static extern string nativeGetDurationJson(string jsonMessage, string callerId);

            [DllImport ("AmazonFlingServiceBridge")]
            private static extern string nativeGetStatusJson(string jsonMessage, string callerId);

            [DllImport ("AmazonFlingServiceBridge")]
            private static extern string nativeIsMimeTypeSupportedJson(string jsonMessage, string callerId);

            [DllImport ("AmazonFlingServiceBridge")]
            private static extern string nativePauseJson(string jsonMessage, string callerId);

            [DllImport ("AmazonFlingServiceBridge")]
            private static extern string nativePlayJson(string jsonMessage, string callerId);

            [DllImport ("AmazonFlingServiceBridge")]
            private static extern string nativeStopJson(string jsonMessage, string callerId);

            [DllImport ("AmazonFlingServiceBridge")]
            private static extern string nativeSeekJson(string jsonMessage, string callerId);

            [DllImport ("AmazonFlingServiceBridge")]
            private static extern string nativeSetMediaSourceJson(string jsonMessage, string callerId);

            [DllImport ("AmazonFlingServiceBridge")]
            private static extern string nativeSetPlayerStyleJson(string jsonMessage, string callerId);

            [DllImport ("AmazonFlingServiceBridge")]
            private static extern string nativeAddStatusListenerJson(string jsonMessage, string callerId);

            [DllImport ("AmazonFlingServiceBridge")]
            private static extern string nativeRemoveStatusListenerJson(string jsonMessage, string callerId);

            [DllImport ("AmazonFlingServiceBridge")]
            private static extern string nativeSetPositionUpdateIntervalJson(string jsonMessage, string callerId);

            [DllImport ("AmazonFlingServiceBridge")]
            private static extern string nativeSendCommandJson(string jsonMessage, string callerId);

            [DllImport ("AmazonFlingServiceBridge")]
            private static extern string nativeGetMediaInfoJson(string jsonMessage, string callerId);

            public static new AmazonFlingServiceUnityAndroid Instance
            {
                get
                {
                    return AmazonFlingServiceUnityBase.getInstance<AmazonFlingServiceUnityAndroid>();
                }
            }

            protected override void NativeInit()
            {
                AmazonFlingServiceUnityAndroid.nativeInit();
            }

            protected override void RegisterCallback()
            {
                AmazonFlingServiceUnityAndroid.nativeRegisterCallbackGameObject(gameObject.name);
            }

            protected override void RegisterEventListener()
            {
                AmazonFlingServiceUnityAndroid.nativeRegisterCallbackGameObject(gameObject.name);
            }

            protected override void NativeRegisterCrossPlatformTool(string crossPlatformTool)
            {
            }

            protected override string NativeStartDiscoveryJson(string jsonMessage)
            {
                return AmazonFlingServiceUnityAndroid.nativeStartDiscoveryJson(jsonMessage);
            }

            protected override string NativeStopDiscoveryJson(string jsonMessage)
            {
                return AmazonFlingServiceUnityAndroid.nativeStopDiscoveryJson(jsonMessage);
            }

            protected override string NativeGetVolumeJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityAndroid.nativeGetVolumeJson(jsonMessage, callerId);
            }

            protected override string NativeSetVolumeJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityAndroid.nativeSetVolumeJson(jsonMessage, callerId);
            }

            protected override string NativeIsMuteJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityAndroid.nativeIsMuteJson(jsonMessage, callerId);
            }

            protected override string NativeSetMuteJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityAndroid.nativeSetMuteJson(jsonMessage, callerId);
            }

            protected override string NativeGetPositionJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityAndroid.nativeGetPositionJson(jsonMessage, callerId);
            }

            protected override string NativeGetDurationJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityAndroid.nativeGetDurationJson(jsonMessage, callerId);
            }

            protected override string NativeGetStatusJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityAndroid.nativeGetStatusJson(jsonMessage, callerId);
            }

            protected override string NativeIsMimeTypeSupportedJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityAndroid.nativeIsMimeTypeSupportedJson(jsonMessage, callerId);
            }

            protected override string NativePauseJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityAndroid.nativePauseJson(jsonMessage, callerId);
            }

            protected override string NativePlayJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityAndroid.nativePlayJson(jsonMessage, callerId);
            }

            protected override string NativeStopJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityAndroid.nativeStopJson(jsonMessage, callerId);
            }

            protected override string NativeSeekJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityAndroid.nativeSeekJson(jsonMessage, callerId);
            }

            protected override string NativeSetMediaSourceJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityAndroid.nativeSetMediaSourceJson(jsonMessage, callerId);
            }

            protected override string NativeSetPlayerStyleJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityAndroid.nativeSetPlayerStyleJson(jsonMessage, callerId);
            }

            protected override string NativeAddStatusListenerJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityAndroid.nativeAddStatusListenerJson(jsonMessage, callerId);
            }

            protected override string NativeRemoveStatusListenerJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityAndroid.nativeRemoveStatusListenerJson(jsonMessage, callerId);
            }

            protected override string NativeSetPositionUpdateIntervalJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityAndroid.nativeSetPositionUpdateIntervalJson(jsonMessage, callerId);
            }

            protected override string NativeSendCommandJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityAndroid.nativeSendCommandJson(jsonMessage, callerId);
            }

            protected override string NativeGetMediaInfoJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityAndroid.nativeGetMediaInfoJson(jsonMessage, callerId);
            }

        }
#endif
    }
}

