
/* 
* Copyright 2014 Amazon.com,
* Inc. or its affiliates. All Rights Reserved.
*
* Licensed under the Apache License, Version 2.0 (the
* "License"). You may not use this file except in compliance
* with the License. A copy of the License is located at
*
* http://aws.amazon.com/apache2.0/
*
* or in the "license" file accompanying this file. This file is
* distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
* CONDITIONS OF ANY KIND, either express or implied. See the
* License for the specific language governing permissions and
* limitations under the License.
*/


using System.Runtime.InteropServices;
#if UNITY_IPHONE
using UnityEngine;
#endif
namespace com.amazon.whisperplay.fling.cpt.media.controller
{
    public abstract partial class AmazonFlingServiceImpl
    {
#if UNITY_IPHONE
        private class AmazonFlingServiceUnityIPhone : AmazonFlingServiceUnityBase
        {
            [DllImport ("__Internal")]
            private static extern string nativeRegisterCallbackGameObject(string name);

            [DllImport ("__Internal")]
            private static extern string nativeRegisterCrossPlatformTool(string crossPlatformTool);

            [DllImport ("__Internal")]
            private static extern string nativeStartDiscoveryJson(string jsonMessage);

            [DllImport ("__Internal")]
            private static extern string nativeStopDiscoveryJson(string jsonMessage);

            [DllImport ("__Internal")]
            private static extern string nativeGetVolumeJson(string jsonMessage, string callerId);

            [DllImport ("__Internal")]
            private static extern string nativeSetVolumeJson(string jsonMessage, string callerId);

            [DllImport ("__Internal")]
            private static extern string nativeIsMuteJson(string jsonMessage, string callerId);

            [DllImport ("__Internal")]
            private static extern string nativeSetMuteJson(string jsonMessage, string callerId);

            [DllImport ("__Internal")]
            private static extern string nativeGetPositionJson(string jsonMessage, string callerId);

            [DllImport ("__Internal")]
            private static extern string nativeGetDurationJson(string jsonMessage, string callerId);

            [DllImport ("__Internal")]
            private static extern string nativeGetStatusJson(string jsonMessage, string callerId);

            [DllImport ("__Internal")]
            private static extern string nativeIsMimeTypeSupportedJson(string jsonMessage, string callerId);

            [DllImport ("__Internal")]
            private static extern string nativePauseJson(string jsonMessage, string callerId);

            [DllImport ("__Internal")]
            private static extern string nativePlayJson(string jsonMessage, string callerId);

            [DllImport ("__Internal")]
            private static extern string nativeStopJson(string jsonMessage, string callerId);

            [DllImport ("__Internal")]
            private static extern string nativeSeekJson(string jsonMessage, string callerId);

            [DllImport ("__Internal")]
            private static extern string nativeSetMediaSourceJson(string jsonMessage, string callerId);

            [DllImport ("__Internal")]
            private static extern string nativeSetPlayerStyleJson(string jsonMessage, string callerId);

            [DllImport ("__Internal")]
            private static extern string nativeAddStatusListenerJson(string jsonMessage, string callerId);

            [DllImport ("__Internal")]
            private static extern string nativeRemoveStatusListenerJson(string jsonMessage, string callerId);

            [DllImport ("__Internal")]
            private static extern string nativeSetPositionUpdateIntervalJson(string jsonMessage, string callerId);

            [DllImport ("__Internal")]
            private static extern string nativeSendCommandJson(string jsonMessage, string callerId);

            [DllImport ("__Internal")]
            private static extern string nativeGetMediaInfoJson(string jsonMessage, string callerId);

            public static new AmazonFlingServiceUnityIPhone Instance
            {
                get
                {
                    return AmazonFlingServiceUnityBase.getInstance<AmazonFlingServiceUnityIPhone>();
                }
            }

            protected override void NativeInit()
            {
                //do nothing
            }

            protected override void RegisterCallback()
            {
                AmazonFlingServiceUnityIPhone.nativeRegisterCallbackGameObject(gameObject.name);
            }

            protected override void RegisterEventListener()
            {
                AmazonFlingServiceUnityIPhone.nativeRegisterCallbackGameObject(gameObject.name);
            }

            protected override void NativeRegisterCrossPlatformTool(string crossPlatformTool)
            {
                AmazonFlingServiceUnityIPhone.nativeRegisterCrossPlatformTool(crossPlatformTool);
            }

            protected override string NativeStartDiscoveryJson(string jsonMessage)
            {
                return AmazonFlingServiceUnityIPhone.nativeStartDiscoveryJson(jsonMessage);
            }

            protected override string NativeStopDiscoveryJson(string jsonMessage)
            {
                return AmazonFlingServiceUnityIPhone.nativeStopDiscoveryJson(jsonMessage);
            }

            protected override string NativeGetVolumeJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityIPhone.nativeGetVolumeJson(jsonMessage, callerId);
            }

            protected override string NativeSetVolumeJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityIPhone.nativeSetVolumeJson(jsonMessage, callerId);
            }

            protected override string NativeIsMuteJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityIPhone.nativeIsMuteJson(jsonMessage, callerId);
            }

            protected override string NativeSetMuteJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityIPhone.nativeSetMuteJson(jsonMessage, callerId);
            }

            protected override string NativeGetPositionJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityIPhone.nativeGetPositionJson(jsonMessage, callerId);
            }

            protected override string NativeGetDurationJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityIPhone.nativeGetDurationJson(jsonMessage, callerId);
            }

            protected override string NativeGetStatusJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityIPhone.nativeGetStatusJson(jsonMessage, callerId);
            }

            protected override string NativeIsMimeTypeSupportedJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityIPhone.nativeIsMimeTypeSupportedJson(jsonMessage, callerId);
            }

            protected override string NativePauseJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityIPhone.nativePauseJson(jsonMessage, callerId);
            }

            protected override string NativePlayJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityIPhone.nativePlayJson(jsonMessage, callerId);
            }

            protected override string NativeStopJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityIPhone.nativeStopJson(jsonMessage, callerId);
            }

            protected override string NativeSeekJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityIPhone.nativeSeekJson(jsonMessage, callerId);
            }

            protected override string NativeSetMediaSourceJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityIPhone.nativeSetMediaSourceJson(jsonMessage, callerId);
            }

            protected override string NativeSetPlayerStyleJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityIPhone.nativeSetPlayerStyleJson(jsonMessage, callerId);
            }

            protected override string NativeAddStatusListenerJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityIPhone.nativeAddStatusListenerJson(jsonMessage, callerId);
            }

            protected override string NativeRemoveStatusListenerJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityIPhone.nativeRemoveStatusListenerJson(jsonMessage, callerId);
            }

            protected override string NativeSetPositionUpdateIntervalJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityIPhone.nativeSetPositionUpdateIntervalJson(jsonMessage, callerId);
            }

            protected override string NativeSendCommandJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityIPhone.nativeSendCommandJson(jsonMessage, callerId);
            }

            protected override string NativeGetMediaInfoJson(string jsonMessage, string callerId)
            {
                return AmazonFlingServiceUnityIPhone.nativeGetMediaInfoJson(jsonMessage, callerId);
            }

        }
#endif
    }
}

