
/* 
* Copyright 2014 Amazon.com,
* Inc. or its affiliates. All Rights Reserved.
*
* Licensed under the Apache License, Version 2.0 (the
* "License"). You may not use this file except in compliance
* with the License. A copy of the License is located at
*
* http://aws.amazon.com/apache2.0/
*
* or in the "license" file accompanying this file. This file is
* distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
* CONDITIONS OF ANY KIND, either express or implied. See the
* License for the specific language governing permissions and
* limitations under the License.
*/

//
//  AMAZONAmazonFlingServiceBridge.h
//


#import <Foundation/Foundation.h>

@interface AMAZONAmazonFlingServiceBridge : NSObject
typedef void (*callback_delegate)(const char*);
#ifdef __cplusplus
extern "C" {
#endif
char* nativeRegisterEventListener(callback_delegate callback);
char* nativeRegisterCallbackGameObject(char* name);
char* nativeRegisterCrossPlatformTool(char* name);
char* nativeStartDiscoveryJson (const char* playerServiceId);
char* nativeStopDiscoveryJson (const char* voidArgument);
char* nativeGetVolumeJson (const char* player, const char* uuid);
char* nativeSetVolumeJson (const char* setVolumeParameters, const char* uuid);
char* nativeIsMuteJson (const char* player, const char* uuid);
char* nativeSetMuteJson (const char* muteParameters, const char* uuid);
char* nativeGetPositionJson (const char* player, const char* uuid);
char* nativeGetDurationJson (const char* player, const char* uuid);
char* nativeGetStatusJson (const char* player, const char* uuid);
char* nativeIsMimeTypeSupportedJson (const char* isMimeTypeSupportedParameters, const char* uuid);
char* nativePauseJson (const char* player, const char* uuid);
char* nativePlayJson (const char* player, const char* uuid);
char* nativeStopJson (const char* player, const char* uuid);
char* nativeSeekJson (const char* playerSeekParameters, const char* uuid);
char* nativeSetMediaSourceJson (const char* setMediaSourceParameters, const char* uuid);
char* nativeSetPlayerStyleJson (const char* setPlayerStyleParameters, const char* uuid);
char* nativeAddStatusListenerJson (const char* player, const char* uuid);
char* nativeRemoveStatusListenerJson (const char* player, const char* uuid);
char* nativeSetPositionUpdateIntervalJson (const char* setPositionUpdateIntervalParameters, const char* uuid);
char* nativeSendCommandJson (const char* sendCommandParameters, const char* uuid);
char* nativeGetMediaInfoJson (const char* player, const char* uuid);
const char* nativeRegisterCallback(callback_delegate callback);
#ifdef __cplusplus
}
#endif

@end
