
/* 
* Copyright 2014 Amazon.com,
* Inc. or its affiliates. All Rights Reserved.
*
* Licensed under the Apache License, Version 2.0 (the
* "License"). You may not use this file except in compliance
* with the License. A copy of the License is located at
*
* http://aws.amazon.com/apache2.0/
*
* or in the "license" file accompanying this file. This file is
* distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
* CONDITIONS OF ANY KIND, either express or implied. See the
* License for the specific language governing permissions and
* limitations under the License.
*/

//
//  AMAZONAmazonFlingServiceImplStub.h
//


#import <Foundation/Foundation.h>
#import "AMAZONAmazonFlingService.h"

typedef enum AMAZONAmazonFlingServiceErrorCodes : NSUInteger {
    startDiscoveryError = 0,
    stopDiscoveryError = 1,
    getVolumeError = 2,
    setVolumeError = 3,
    isMuteError = 4,
    setMuteError = 5,
    getPositionError = 6,
    getDurationError = 7,
    getStatusError = 8,
    isMimeTypeSupportedError = 9,
    pauseError = 10,
    playError = 11,
    stopError = 12,
    seekError = 13,
    setMediaSourceError = 14,
    setPlayerStyleError = 15,
    addStatusListenerError = 16,
    removeStatusListenerError = 17,
    setPositionUpdateIntervalError = 18,
    sendCommandError = 19,
    getMediaInfoError = 20,
} AMAZONAmazonFlingServiceErrorCodes;

@interface AMAZONAmazonFlingServiceImplStub : NSObject <AMAZONAmazonFlingService>

@end

