
/* 
* Copyright 2014 Amazon.com,
* Inc. or its affiliates. All Rights Reserved.
*
* Licensed under the Apache License, Version 2.0 (the
* "License"). You may not use this file except in compliance
* with the License. A copy of the License is located at
*
* http://aws.amazon.com/apache2.0/
*
* or in the "license" file accompanying this file. This file is
* distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
* CONDITIONS OF ANY KIND, either express or implied. See the
* License for the specific language governing permissions and
* limitations under the License.
*/

//
//  AMAZONAmazonFlingServiceImplStub.m
//


#import "AMAZONAmazonFlingServiceImplStub.h"

@implementation AMAZONAmazonFlingServiceImplStub

@synthesize controller = _controller;

- (void)startDiscovery:(AMAZONPlayerServiceId *)playerServiceId error:(NSError *__autoreleasing *)errorPtr {
    return;
}

- (void)stopDiscoveryWithError:(NSError *__autoreleasing *)errorPtr {
    return;
}

- (void)getVolume:(AMAZONPlayer *)player completion:(futureDoubleResultBlock)response {
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        // ret is the object you will send in the future, replace it with the actual object you're returnings
        __block AMAZONDoubleResult * ret = [[AMAZONDoubleResult alloc] init];
        // TODO: Async operation implementation
        
        // When the async task finishes, it lets the main thread know and passes in the completed future object
        dispatch_async(dispatch_get_main_queue(), ^{
            // TODO: set ret equal to the future object that you have completed

            NSError* error = nil;
            if(ret == nil) {
                NSString* domain = @"com.amazon.AmazonFlingService.ErrorDomain";
                NSUInteger errorCode = getVolumeError;
                NSMutableDictionary* userInfo = [NSMutableDictionary dictionary];
                // TODO: change the following setObject parameter to a more appropriate error; this is the message that is passed up to the API layer
                [userInfo setObject:@"An error occured in getVolume" forKey:NSLocalizedDescriptionKey];
                error = [[NSError alloc] initWithDomain:domain code:errorCode userInfo:userInfo];
                response(ret, error);
                return;
            } else {
                response(ret, error);
                return;
            }
        });
    });
}

- (void)setVolume:(AMAZONSetVolumeParameters *)setVolumeParameters completion:(futureVoidResultBlock)response {
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        // ret is the object you will send in the future, replace it with the actual object you're returnings
        __block AMAZONVoidResult * ret = [[AMAZONVoidResult alloc] init];
        // TODO: Async operation implementation
        
        // When the async task finishes, it lets the main thread know and passes in the completed future object
        dispatch_async(dispatch_get_main_queue(), ^{
            // TODO: set ret equal to the future object that you have completed

            NSError* error = nil;
            if(ret == nil) {
                NSString* domain = @"com.amazon.AmazonFlingService.ErrorDomain";
                NSUInteger errorCode = setVolumeError;
                NSMutableDictionary* userInfo = [NSMutableDictionary dictionary];
                // TODO: change the following setObject parameter to a more appropriate error; this is the message that is passed up to the API layer
                [userInfo setObject:@"An error occured in setVolume" forKey:NSLocalizedDescriptionKey];
                error = [[NSError alloc] initWithDomain:domain code:errorCode userInfo:userInfo];
                response(ret, error);
                return;
            } else {
                response(ret, error);
                return;
            }
        });
    });
}

- (void)isMute:(AMAZONPlayer *)player completion:(futureBooleanResultBlock)response {
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        // ret is the object you will send in the future, replace it with the actual object you're returnings
        __block AMAZONBooleanResult * ret = [[AMAZONBooleanResult alloc] init];
        // TODO: Async operation implementation
        
        // When the async task finishes, it lets the main thread know and passes in the completed future object
        dispatch_async(dispatch_get_main_queue(), ^{
            // TODO: set ret equal to the future object that you have completed

            NSError* error = nil;
            if(ret == nil) {
                NSString* domain = @"com.amazon.AmazonFlingService.ErrorDomain";
                NSUInteger errorCode = isMuteError;
                NSMutableDictionary* userInfo = [NSMutableDictionary dictionary];
                // TODO: change the following setObject parameter to a more appropriate error; this is the message that is passed up to the API layer
                [userInfo setObject:@"An error occured in isMute" forKey:NSLocalizedDescriptionKey];
                error = [[NSError alloc] initWithDomain:domain code:errorCode userInfo:userInfo];
                response(ret, error);
                return;
            } else {
                response(ret, error);
                return;
            }
        });
    });
}

- (void)setMute:(AMAZONMuteParameters *)muteParameters completion:(futureVoidResultBlock)response {
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        // ret is the object you will send in the future, replace it with the actual object you're returnings
        __block AMAZONVoidResult * ret = [[AMAZONVoidResult alloc] init];
        // TODO: Async operation implementation
        
        // When the async task finishes, it lets the main thread know and passes in the completed future object
        dispatch_async(dispatch_get_main_queue(), ^{
            // TODO: set ret equal to the future object that you have completed

            NSError* error = nil;
            if(ret == nil) {
                NSString* domain = @"com.amazon.AmazonFlingService.ErrorDomain";
                NSUInteger errorCode = setMuteError;
                NSMutableDictionary* userInfo = [NSMutableDictionary dictionary];
                // TODO: change the following setObject parameter to a more appropriate error; this is the message that is passed up to the API layer
                [userInfo setObject:@"An error occured in setMute" forKey:NSLocalizedDescriptionKey];
                error = [[NSError alloc] initWithDomain:domain code:errorCode userInfo:userInfo];
                response(ret, error);
                return;
            } else {
                response(ret, error);
                return;
            }
        });
    });
}

- (void)getPosition:(AMAZONPlayer *)player completion:(futureLongResultBlock)response {
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        // ret is the object you will send in the future, replace it with the actual object you're returnings
        __block AMAZONLongResult * ret = [[AMAZONLongResult alloc] init];
        // TODO: Async operation implementation
        
        // When the async task finishes, it lets the main thread know and passes in the completed future object
        dispatch_async(dispatch_get_main_queue(), ^{
            // TODO: set ret equal to the future object that you have completed

            NSError* error = nil;
            if(ret == nil) {
                NSString* domain = @"com.amazon.AmazonFlingService.ErrorDomain";
                NSUInteger errorCode = getPositionError;
                NSMutableDictionary* userInfo = [NSMutableDictionary dictionary];
                // TODO: change the following setObject parameter to a more appropriate error; this is the message that is passed up to the API layer
                [userInfo setObject:@"An error occured in getPosition" forKey:NSLocalizedDescriptionKey];
                error = [[NSError alloc] initWithDomain:domain code:errorCode userInfo:userInfo];
                response(ret, error);
                return;
            } else {
                response(ret, error);
                return;
            }
        });
    });
}

- (void)getDuration:(AMAZONPlayer *)player completion:(futureLongResultBlock)response {
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        // ret is the object you will send in the future, replace it with the actual object you're returnings
        __block AMAZONLongResult * ret = [[AMAZONLongResult alloc] init];
        // TODO: Async operation implementation
        
        // When the async task finishes, it lets the main thread know and passes in the completed future object
        dispatch_async(dispatch_get_main_queue(), ^{
            // TODO: set ret equal to the future object that you have completed

            NSError* error = nil;
            if(ret == nil) {
                NSString* domain = @"com.amazon.AmazonFlingService.ErrorDomain";
                NSUInteger errorCode = getDurationError;
                NSMutableDictionary* userInfo = [NSMutableDictionary dictionary];
                // TODO: change the following setObject parameter to a more appropriate error; this is the message that is passed up to the API layer
                [userInfo setObject:@"An error occured in getDuration" forKey:NSLocalizedDescriptionKey];
                error = [[NSError alloc] initWithDomain:domain code:errorCode userInfo:userInfo];
                response(ret, error);
                return;
            } else {
                response(ret, error);
                return;
            }
        });
    });
}

- (void)getStatus:(AMAZONPlayer *)player completion:(futureStatusBlock)response {
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        // ret is the object you will send in the future, replace it with the actual object you're returnings
        __block AMAZONStatus * ret = [[AMAZONStatus alloc] init];
        // TODO: Async operation implementation
        
        // When the async task finishes, it lets the main thread know and passes in the completed future object
        dispatch_async(dispatch_get_main_queue(), ^{
            // TODO: set ret equal to the future object that you have completed

            NSError* error = nil;
            if(ret == nil) {
                NSString* domain = @"com.amazon.AmazonFlingService.ErrorDomain";
                NSUInteger errorCode = getStatusError;
                NSMutableDictionary* userInfo = [NSMutableDictionary dictionary];
                // TODO: change the following setObject parameter to a more appropriate error; this is the message that is passed up to the API layer
                [userInfo setObject:@"An error occured in getStatus" forKey:NSLocalizedDescriptionKey];
                error = [[NSError alloc] initWithDomain:domain code:errorCode userInfo:userInfo];
                response(ret, error);
                return;
            } else {
                response(ret, error);
                return;
            }
        });
    });
}

- (void)isMimeTypeSupported:(AMAZONIsMimeTypeSupportedParameters *)isMimeTypeSupportedParameters completion:(futureBooleanResultBlock)response {
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        // ret is the object you will send in the future, replace it with the actual object you're returnings
        __block AMAZONBooleanResult * ret = [[AMAZONBooleanResult alloc] init];
        // TODO: Async operation implementation
        
        // When the async task finishes, it lets the main thread know and passes in the completed future object
        dispatch_async(dispatch_get_main_queue(), ^{
            // TODO: set ret equal to the future object that you have completed

            NSError* error = nil;
            if(ret == nil) {
                NSString* domain = @"com.amazon.AmazonFlingService.ErrorDomain";
                NSUInteger errorCode = isMimeTypeSupportedError;
                NSMutableDictionary* userInfo = [NSMutableDictionary dictionary];
                // TODO: change the following setObject parameter to a more appropriate error; this is the message that is passed up to the API layer
                [userInfo setObject:@"An error occured in isMimeTypeSupported" forKey:NSLocalizedDescriptionKey];
                error = [[NSError alloc] initWithDomain:domain code:errorCode userInfo:userInfo];
                response(ret, error);
                return;
            } else {
                response(ret, error);
                return;
            }
        });
    });
}

- (void)pause:(AMAZONPlayer *)player completion:(futureVoidResultBlock)response {
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        // ret is the object you will send in the future, replace it with the actual object you're returnings
        __block AMAZONVoidResult * ret = [[AMAZONVoidResult alloc] init];
        // TODO: Async operation implementation
        
        // When the async task finishes, it lets the main thread know and passes in the completed future object
        dispatch_async(dispatch_get_main_queue(), ^{
            // TODO: set ret equal to the future object that you have completed

            NSError* error = nil;
            if(ret == nil) {
                NSString* domain = @"com.amazon.AmazonFlingService.ErrorDomain";
                NSUInteger errorCode = pauseError;
                NSMutableDictionary* userInfo = [NSMutableDictionary dictionary];
                // TODO: change the following setObject parameter to a more appropriate error; this is the message that is passed up to the API layer
                [userInfo setObject:@"An error occured in pause" forKey:NSLocalizedDescriptionKey];
                error = [[NSError alloc] initWithDomain:domain code:errorCode userInfo:userInfo];
                response(ret, error);
                return;
            } else {
                response(ret, error);
                return;
            }
        });
    });
}

- (void)play:(AMAZONPlayer *)player completion:(futureVoidResultBlock)response {
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        // ret is the object you will send in the future, replace it with the actual object you're returnings
        __block AMAZONVoidResult * ret = [[AMAZONVoidResult alloc] init];
        // TODO: Async operation implementation
        
        // When the async task finishes, it lets the main thread know and passes in the completed future object
        dispatch_async(dispatch_get_main_queue(), ^{
            // TODO: set ret equal to the future object that you have completed

            NSError* error = nil;
            if(ret == nil) {
                NSString* domain = @"com.amazon.AmazonFlingService.ErrorDomain";
                NSUInteger errorCode = playError;
                NSMutableDictionary* userInfo = [NSMutableDictionary dictionary];
                // TODO: change the following setObject parameter to a more appropriate error; this is the message that is passed up to the API layer
                [userInfo setObject:@"An error occured in play" forKey:NSLocalizedDescriptionKey];
                error = [[NSError alloc] initWithDomain:domain code:errorCode userInfo:userInfo];
                response(ret, error);
                return;
            } else {
                response(ret, error);
                return;
            }
        });
    });
}

- (void)stop:(AMAZONPlayer *)player completion:(futureVoidResultBlock)response {
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        // ret is the object you will send in the future, replace it with the actual object you're returnings
        __block AMAZONVoidResult * ret = [[AMAZONVoidResult alloc] init];
        // TODO: Async operation implementation
        
        // When the async task finishes, it lets the main thread know and passes in the completed future object
        dispatch_async(dispatch_get_main_queue(), ^{
            // TODO: set ret equal to the future object that you have completed

            NSError* error = nil;
            if(ret == nil) {
                NSString* domain = @"com.amazon.AmazonFlingService.ErrorDomain";
                NSUInteger errorCode = stopError;
                NSMutableDictionary* userInfo = [NSMutableDictionary dictionary];
                // TODO: change the following setObject parameter to a more appropriate error; this is the message that is passed up to the API layer
                [userInfo setObject:@"An error occured in stop" forKey:NSLocalizedDescriptionKey];
                error = [[NSError alloc] initWithDomain:domain code:errorCode userInfo:userInfo];
                response(ret, error);
                return;
            } else {
                response(ret, error);
                return;
            }
        });
    });
}

- (void)seek:(AMAZONPlayerSeekParameters *)playerSeekParameters completion:(futureVoidResultBlock)response {
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        // ret is the object you will send in the future, replace it with the actual object you're returnings
        __block AMAZONVoidResult * ret = [[AMAZONVoidResult alloc] init];
        // TODO: Async operation implementation
        
        // When the async task finishes, it lets the main thread know and passes in the completed future object
        dispatch_async(dispatch_get_main_queue(), ^{
            // TODO: set ret equal to the future object that you have completed

            NSError* error = nil;
            if(ret == nil) {
                NSString* domain = @"com.amazon.AmazonFlingService.ErrorDomain";
                NSUInteger errorCode = seekError;
                NSMutableDictionary* userInfo = [NSMutableDictionary dictionary];
                // TODO: change the following setObject parameter to a more appropriate error; this is the message that is passed up to the API layer
                [userInfo setObject:@"An error occured in seek" forKey:NSLocalizedDescriptionKey];
                error = [[NSError alloc] initWithDomain:domain code:errorCode userInfo:userInfo];
                response(ret, error);
                return;
            } else {
                response(ret, error);
                return;
            }
        });
    });
}

- (void)setMediaSource:(AMAZONSetMediaSourceParameters *)setMediaSourceParameters completion:(futureVoidResultBlock)response {
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        // ret is the object you will send in the future, replace it with the actual object you're returnings
        __block AMAZONVoidResult * ret = [[AMAZONVoidResult alloc] init];
        // TODO: Async operation implementation
        
        // When the async task finishes, it lets the main thread know and passes in the completed future object
        dispatch_async(dispatch_get_main_queue(), ^{
            // TODO: set ret equal to the future object that you have completed

            NSError* error = nil;
            if(ret == nil) {
                NSString* domain = @"com.amazon.AmazonFlingService.ErrorDomain";
                NSUInteger errorCode = setMediaSourceError;
                NSMutableDictionary* userInfo = [NSMutableDictionary dictionary];
                // TODO: change the following setObject parameter to a more appropriate error; this is the message that is passed up to the API layer
                [userInfo setObject:@"An error occured in setMediaSource" forKey:NSLocalizedDescriptionKey];
                error = [[NSError alloc] initWithDomain:domain code:errorCode userInfo:userInfo];
                response(ret, error);
                return;
            } else {
                response(ret, error);
                return;
            }
        });
    });
}

- (void)setPlayerStyle:(AMAZONSetPlayerStyleParameters *)setPlayerStyleParameters completion:(futureVoidResultBlock)response {
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        // ret is the object you will send in the future, replace it with the actual object you're returnings
        __block AMAZONVoidResult * ret = [[AMAZONVoidResult alloc] init];
        // TODO: Async operation implementation
        
        // When the async task finishes, it lets the main thread know and passes in the completed future object
        dispatch_async(dispatch_get_main_queue(), ^{
            // TODO: set ret equal to the future object that you have completed

            NSError* error = nil;
            if(ret == nil) {
                NSString* domain = @"com.amazon.AmazonFlingService.ErrorDomain";
                NSUInteger errorCode = setPlayerStyleError;
                NSMutableDictionary* userInfo = [NSMutableDictionary dictionary];
                // TODO: change the following setObject parameter to a more appropriate error; this is the message that is passed up to the API layer
                [userInfo setObject:@"An error occured in setPlayerStyle" forKey:NSLocalizedDescriptionKey];
                error = [[NSError alloc] initWithDomain:domain code:errorCode userInfo:userInfo];
                response(ret, error);
                return;
            } else {
                response(ret, error);
                return;
            }
        });
    });
}

- (void)addStatusListener:(AMAZONPlayer *)player completion:(futureVoidResultBlock)response {
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        // ret is the object you will send in the future, replace it with the actual object you're returnings
        __block AMAZONVoidResult * ret = [[AMAZONVoidResult alloc] init];
        // TODO: Async operation implementation
        
        // When the async task finishes, it lets the main thread know and passes in the completed future object
        dispatch_async(dispatch_get_main_queue(), ^{
            // TODO: set ret equal to the future object that you have completed

            NSError* error = nil;
            if(ret == nil) {
                NSString* domain = @"com.amazon.AmazonFlingService.ErrorDomain";
                NSUInteger errorCode = addStatusListenerError;
                NSMutableDictionary* userInfo = [NSMutableDictionary dictionary];
                // TODO: change the following setObject parameter to a more appropriate error; this is the message that is passed up to the API layer
                [userInfo setObject:@"An error occured in addStatusListener" forKey:NSLocalizedDescriptionKey];
                error = [[NSError alloc] initWithDomain:domain code:errorCode userInfo:userInfo];
                response(ret, error);
                return;
            } else {
                response(ret, error);
                return;
            }
        });
    });
}

- (void)removeStatusListener:(AMAZONPlayer *)player completion:(futureVoidResultBlock)response {
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        // ret is the object you will send in the future, replace it with the actual object you're returnings
        __block AMAZONVoidResult * ret = [[AMAZONVoidResult alloc] init];
        // TODO: Async operation implementation
        
        // When the async task finishes, it lets the main thread know and passes in the completed future object
        dispatch_async(dispatch_get_main_queue(), ^{
            // TODO: set ret equal to the future object that you have completed

            NSError* error = nil;
            if(ret == nil) {
                NSString* domain = @"com.amazon.AmazonFlingService.ErrorDomain";
                NSUInteger errorCode = removeStatusListenerError;
                NSMutableDictionary* userInfo = [NSMutableDictionary dictionary];
                // TODO: change the following setObject parameter to a more appropriate error; this is the message that is passed up to the API layer
                [userInfo setObject:@"An error occured in removeStatusListener" forKey:NSLocalizedDescriptionKey];
                error = [[NSError alloc] initWithDomain:domain code:errorCode userInfo:userInfo];
                response(ret, error);
                return;
            } else {
                response(ret, error);
                return;
            }
        });
    });
}

- (void)setPositionUpdateInterval:(AMAZONSetPositionUpdateIntervalParameters *)setPositionUpdateIntervalParameters completion:(futureVoidResultBlock)response {
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        // ret is the object you will send in the future, replace it with the actual object you're returnings
        __block AMAZONVoidResult * ret = [[AMAZONVoidResult alloc] init];
        // TODO: Async operation implementation
        
        // When the async task finishes, it lets the main thread know and passes in the completed future object
        dispatch_async(dispatch_get_main_queue(), ^{
            // TODO: set ret equal to the future object that you have completed

            NSError* error = nil;
            if(ret == nil) {
                NSString* domain = @"com.amazon.AmazonFlingService.ErrorDomain";
                NSUInteger errorCode = setPositionUpdateIntervalError;
                NSMutableDictionary* userInfo = [NSMutableDictionary dictionary];
                // TODO: change the following setObject parameter to a more appropriate error; this is the message that is passed up to the API layer
                [userInfo setObject:@"An error occured in setPositionUpdateInterval" forKey:NSLocalizedDescriptionKey];
                error = [[NSError alloc] initWithDomain:domain code:errorCode userInfo:userInfo];
                response(ret, error);
                return;
            } else {
                response(ret, error);
                return;
            }
        });
    });
}

- (void)sendCommand:(AMAZONSendCommandParameters *)sendCommandParameters completion:(futureVoidResultBlock)response {
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        // ret is the object you will send in the future, replace it with the actual object you're returnings
        __block AMAZONVoidResult * ret = [[AMAZONVoidResult alloc] init];
        // TODO: Async operation implementation
        
        // When the async task finishes, it lets the main thread know and passes in the completed future object
        dispatch_async(dispatch_get_main_queue(), ^{
            // TODO: set ret equal to the future object that you have completed

            NSError* error = nil;
            if(ret == nil) {
                NSString* domain = @"com.amazon.AmazonFlingService.ErrorDomain";
                NSUInteger errorCode = sendCommandError;
                NSMutableDictionary* userInfo = [NSMutableDictionary dictionary];
                // TODO: change the following setObject parameter to a more appropriate error; this is the message that is passed up to the API layer
                [userInfo setObject:@"An error occured in sendCommand" forKey:NSLocalizedDescriptionKey];
                error = [[NSError alloc] initWithDomain:domain code:errorCode userInfo:userInfo];
                response(ret, error);
                return;
            } else {
                response(ret, error);
                return;
            }
        });
    });
}

- (void)getMediaInfo:(AMAZONPlayer *)player completion:(futurePlayerInfoBlock)response {
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        // ret is the object you will send in the future, replace it with the actual object you're returnings
        __block AMAZONPlayerInfo * ret = [[AMAZONPlayerInfo alloc] init];
        // TODO: Async operation implementation
        
        // When the async task finishes, it lets the main thread know and passes in the completed future object
        dispatch_async(dispatch_get_main_queue(), ^{
            // TODO: set ret equal to the future object that you have completed

            NSError* error = nil;
            if(ret == nil) {
                NSString* domain = @"com.amazon.AmazonFlingService.ErrorDomain";
                NSUInteger errorCode = getMediaInfoError;
                NSMutableDictionary* userInfo = [NSMutableDictionary dictionary];
                // TODO: change the following setObject parameter to a more appropriate error; this is the message that is passed up to the API layer
                [userInfo setObject:@"An error occured in getMediaInfo" forKey:NSLocalizedDescriptionKey];
                error = [[NSError alloc] initWithDomain:domain code:errorCode userInfo:userInfo];
                response(ret, error);
                return;
            } else {
                response(ret, error);
                return;
            }
        });
    });
}

@end

