
/* 
* Copyright 2014 Amazon.com,
* Inc. or its affiliates. All Rights Reserved.
*
* Licensed under the Apache License, Version 2.0 (the
* "License"). You may not use this file except in compliance
* with the License. A copy of the License is located at
*
* http://aws.amazon.com/apache2.0/
*
* or in the "license" file accompanying this file. This file is
* distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
* CONDITIONS OF ANY KIND, either express or implied. See the
* License for the specific language governing permissions and
* limitations under the License.
*/

//
//  AMAZONAmazonFlingServiceJsonFromObject.h
//


#import <Foundation/Foundation.h>

@class AMAZONDoubleResult;
@class AMAZONVoidResult;
@class AMAZONBooleanResult;
@class AMAZONLongResult;
@class AMAZONStatus;
@class AMAZONPlayerInfo;
@class AMAZONPlayer;
@class AMAZONOnStatusChangeParameters;

@interface AMAZONAmazonFlingServiceJsonFromObject : NSObject

+ (NSData *)jsonFromDoubleResult:(AMAZONDoubleResult *)doubleResult uuid:(NSString *)uuid error:(NSError *__autoreleasing *)errorPtr;
+ (NSData *)jsonFromVoidResult:(AMAZONVoidResult *)voidResult uuid:(NSString *)uuid error:(NSError *__autoreleasing *)errorPtr;
+ (NSData *)jsonFromBooleanResult:(AMAZONBooleanResult *)booleanResult uuid:(NSString *)uuid error:(NSError *__autoreleasing *)errorPtr;
+ (NSData *)jsonFromLongResult:(AMAZONLongResult *)longResult uuid:(NSString *)uuid error:(NSError *__autoreleasing *)errorPtr;
+ (NSData *)jsonFromStatus:(AMAZONStatus *)status uuid:(NSString *)uuid error:(NSError *__autoreleasing *)errorPtr;
+ (NSData *)jsonFromPlayerInfo:(AMAZONPlayerInfo *)playerInfo uuid:(NSString *)uuid error:(NSError *__autoreleasing *)errorPtr;
+ (NSData *)jsonFromVoid;
+ (NSData *)jsonFromError:(NSError *)error;
+ (NSData *)jsonFromFutureError:(NSError *)error uuid:(NSString *)uuid;
+ (NSData *)jsonFromEventError:(NSError *)error eventId:(NSString *)eventId;
+ (NSData *)jsonFromEventNoOutput:(NSString *)eventId;
+ (NSData *)jsonFromPlayerEvent:(AMAZONPlayer *)aMAZONPlayer error:(NSError *__autoreleasing *)errorPtr;
+ (NSData *)jsonFromOnStatusChangeParametersEvent:(AMAZONOnStatusChangeParameters *)aMAZONOnStatusChangeParameters error:(NSError *__autoreleasing *)errorPtr;

@end

