
/* 
* Copyright 2014 Amazon.com,
* Inc. or its affiliates. All Rights Reserved.
*
* Licensed under the Apache License, Version 2.0 (the
* "License"). You may not use this file except in compliance
* with the License. A copy of the License is located at
*
* http://aws.amazon.com/apache2.0/
*
* or in the "license" file accompanying this file. This file is
* distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
* CONDITIONS OF ANY KIND, either express or implied. See the
* License for the specific language governing permissions and
* limitations under the License.
*/

//
//  AMAZONAmazonFlingServiceObjectFromJson.h
//


#import <Foundation/Foundation.h>
@class AMAZONPlayerServiceId;
@class AMAZONPlayer;
@class AMAZONSetVolumeParameters;
@class AMAZONMuteParameters;
@class AMAZONIsMimeTypeSupportedParameters;
@class AMAZONPlayerSeekParameters;
@class AMAZONSetMediaSourceParameters;
@class AMAZONSetPlayerStyleParameters;
@class AMAZONSetPositionUpdateIntervalParameters;
@class AMAZONSendCommandParameters;

@interface AMAZONAmazonFlingServiceObjectFromJson : NSObject

+ (AMAZONPlayerServiceId *)playerServiceIdFromJson:(NSData *)jsonData error:(NSError *__autoreleasing *)errorPtr;
+ (AMAZONPlayer *)playerFromJson:(NSData *)jsonData error:(NSError *__autoreleasing *)errorPtr;
+ (AMAZONSetVolumeParameters *)setVolumeParametersFromJson:(NSData *)jsonData error:(NSError *__autoreleasing *)errorPtr;
            // Already processed: Player
+ (AMAZONMuteParameters *)muteParametersFromJson:(NSData *)jsonData error:(NSError *__autoreleasing *)errorPtr;
            // Already processed: Player
            // Already processed: Player
            // Already processed: Player
+ (AMAZONIsMimeTypeSupportedParameters *)isMimeTypeSupportedParametersFromJson:(NSData *)jsonData error:(NSError *__autoreleasing *)errorPtr;
            // Already processed: Player
            // Already processed: Player
            // Already processed: Player
+ (AMAZONPlayerSeekParameters *)playerSeekParametersFromJson:(NSData *)jsonData error:(NSError *__autoreleasing *)errorPtr;
+ (AMAZONSetMediaSourceParameters *)setMediaSourceParametersFromJson:(NSData *)jsonData error:(NSError *__autoreleasing *)errorPtr;
+ (AMAZONSetPlayerStyleParameters *)setPlayerStyleParametersFromJson:(NSData *)jsonData error:(NSError *__autoreleasing *)errorPtr;
            // Already processed: Player
            // Already processed: Player
+ (AMAZONSetPositionUpdateIntervalParameters *)setPositionUpdateIntervalParametersFromJson:(NSData *)jsonData error:(NSError *__autoreleasing *)errorPtr;
+ (AMAZONSendCommandParameters *)sendCommandParametersFromJson:(NSData *)jsonData error:(NSError *__autoreleasing *)errorPtr;
            // Already processed: Player

@end

