
/* 
* Copyright 2014 Amazon.com,
* Inc. or its affiliates. All Rights Reserved.
*
* Licensed under the Apache License, Version 2.0 (the
* "License"). You may not use this file except in compliance
* with the License. A copy of the License is located at
*
* http://aws.amazon.com/apache2.0/
*
* or in the "license" file accompanying this file. This file is
* distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
* CONDITIONS OF ANY KIND, either express or implied. See the
* License for the specific language governing permissions and
* limitations under the License.
*/

//
//  AMAZONEnums.h
//


#import <Foundation/Foundation.h>

@interface AMAZONEnums : NSObject

typedef enum {
    NOSOURCE,
    PREPARINGMEDIA,
    READYTOPLAY,
    PLAYING,
    PAUSED,
    SEEKING,
    FINISHED,
    ERROR
} AMAZONState;

typedef enum {
    GOOD,
    WARNINGCONTENT,
    WARNINGBANDWIDTH,
    ERRORCONTENT,
    ERRORCHANNEL,
    ERRORUNKNOWN
} AMAZONCondition;

typedef enum {
    PSM_ABSOLUTE,
    PSM_RELATIVE
} AMAZONPlayerSeekMode;


+ (AMAZONState)convertStringToState:(NSString *)stateAsString;
+ (NSString *)convertStateToString:(AMAZONState)state;
+ (AMAZONCondition)convertStringToCondition:(NSString *)conditionAsString;
+ (NSString *)convertConditionToString:(AMAZONCondition)condition;
+ (AMAZONPlayerSeekMode)convertStringToPlayerSeekMode:(NSString *)playerSeekModeAsString;
+ (NSString *)convertPlayerSeekModeToString:(AMAZONPlayerSeekMode)playerSeekMode;

@end
